.Main

  org $8000

.gzxi equ $7c3b

  di
  jr start
.pics
"O"                 ;pics number

.start
  ld e, 6           ;HGFX PAL
  call hgfxpal

  ld a, $20         ;HGFX set
  ld bc, =gzxi      ; linear
  out (c), a        ; borderX
  ld a, 7           ; zxscr off

  inc b
  out (c), a

  ld hl, $5C00      ;pal. clear
  ld (hl), 0
  ld de, $5C01      ; default
  ld bc, 15         ; at 5c00
  ldir

  ld a, 4
  out ($FE), a

  ld a, 255         ;HGFXmemreg
  ld ($5B04), a     ; PlanarMsk

.loop
  ld hl, 0
  ld ($5B07), hl    ; OffSetY

  call rom_off      ;URAM on

  ld a, 131         ;Chunky on
  out ($53), a      ; 10000011

  call rom_on

  xor a             ;esxDOS
  rst 8
db $89              ;drive used
  ld (defdrive), a
  ld hl, =filename  ;open file
  push hl
  pop ix
  ld a, (defdrive)
  ld b, 1
  rst 8
db $9A
  jp c, error
  ld (filehandle), a

  call loader       ;load 7x
  call loader
  call loader       ; 98280B /7
  call loader
  call loader
  call loader
  call loader

  ld hl, $5C00
  ld bc, 12
  call esxload

  ld a, (filehandle);close file
  rst 8
db $9B

  call waitkey

  ld a, (pics)
  ld hl, picnum
  cp (hl)
  jr z, end
  inc (hl)

  ld hl, $5C09
  ld de, $5C06
  ld bc, 3
  ldir
  ld hl, $5C06
  ld de, $5C00
  ld bc, 6
  ldir

  jp loop

.end
  xor a
  jr no_error

.error
  ld a, 2

.no_error
  out ($FE), a

  ld e, 0
  call hgfxpal

  ei
  ret

.hgfxpal
  ld a, 1           ;PAL on/off
  ld bc, =gzxi
  out (c), a
  inc b
  ld a, e           ; e=0 or 6
  out (c), a
  ret

.esxload
  ld a, (filehandle)
  push hl
  pop ix
  rst 8
db $9D
  ret

.loader
  ld hl, 35000
  ld bc, 14040
  call esxload

  call rom_off

  ld b, 78          ;78 lines
  ld hl, 35000      ;load addr

.nextline
  push bc
  ld de, 0          ;transfer
  ld bc, 180        ; to Zone0
  ldir

  push hl
  ld hl, ($5B07)
  inc hl            ;OffsetY+1
  ld ($5B07), hl
  pop hl

  pop bc
  djnz nextline

  call rom_on
  ret

.waitkey
  or a
  in a, ($FE)
  cpl
  and 31
  jr z, waitkey
  ret

.rom_on

  ld a, $10
  ld bc, =gzxi
  out (c), a
  xor a
  inc b
  out (c), a
  ret

.rom_off

  ld a, $10
  ld bc, =gzxi
  out (c), a
  ld a, 2
  inc b
  out (c), a
  ret

.filename
"PICTURE"
.picnum
"A.546"
db 0

.filehandle
db 0

.defdrive
db 0

